/*
 * Created on 2006-8-2
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package com.ibm.cn.wchao;

import java.io.ByteArrayOutputStream;
import java.util.ListResourceBundle;

import javax.mail.Message;
import javax.mail.Flags;
import javax.mail.MessagingException;

import com.ibm.broker.plugin.*;

/**
 * @author michael
 */
public class EmailPOP3_JavaRetrieve extends EmailNode {
	/**
	 * The class is the ResourceBundle containg all the messages for this node.
	 */
	public static class POP3RetrieveNodeMessages extends ListResourceBundle
	{
		public static final String MESSAGE_SOURCE = POP3RetrieveNodeMessages.class.getName();                                                
		public static final String MSGEX = "MSGEX";
		public static final String EX = "EX";
		private Object[][] messages  = {
				{EX, "Exception occured. message: %1, stackTrace: %2"},
				{MSGEX, "MessagingException occured. message: %1, stackTrace: %2"}};
		
		/* (non-Javadoc)
		 * @see java.util.ListResourceBundle#getContents()
		 */
		public Object[][] getContents()
		{
			return messages;
		}
	}
	
	private POP3MailHelper helper = new POP3MailHelper();
	private String pop3Host = null;
	private String pop3User = null;
	private String pop3Password = null;
	private String pop3Folder = null;
	
	public void evaluate(MbMessageAssembly inAssembly) throws MbException {
		String methodName = "evaluate";
		
		MbOutputTerminal out = getOutputTerminal("out");
		MbOutputTerminal alt = getOutputTerminal("alternate");
		
		MbMessage inMessage = inAssembly.getMessage();
		pop3Host = (String) getUserDefinedAttribute("POP3Host");
		pop3User = (String) getUserDefinedAttribute("POP3User");
		pop3Password = (String) getUserDefinedAttribute("POP3Password");
		pop3Folder = (String) getUserDefinedAttribute("POP3Folder");
	
		synchronized (helper) {
			
			if (!helper.isConnected() || !helper.isOpen()) {
				helper.connect(pop3Host, pop3User, pop3Password, pop3Folder, false);
			}
			Message[] incomingEmails = helper.receive();
			if (null == incomingEmails || 0 == incomingEmails.length) {
				// no email polled, passthru the input 
				alt.propagate(inAssembly);
			} else {
				for (int i = 0; i < incomingEmails.length; ++i) {
					try {
						//OutputStream bos = new BufferedOutputStream(new ByteArrayOutputStream());
						ByteArrayOutputStream bos = new ByteArrayOutputStream();
						POP3MailHelper.msg2Stream(incomingEmails[i], bos);
						// Create new message
						MbMessage outMessage = new MbMessage(inMessage);
						MbMessageAssembly outAssembly = new MbMessageAssembly(
								inAssembly, new MbMessage(inAssembly
										.getLocalEnvironment()), inAssembly
										.getExceptionList(), outMessage);

						// Replace the last child with the email body as
						// bitstream
						try {
							outMessage.getRootElement()
								.createElementAsLastChildFromBitstream(
									bos.toByteArray(), MbBLOB.PARSER_NAME,
									null, null, null, 0, 0, 0);
							
							try {
								// Mark the message to be deleted when closing the folder.
								// Note that this is NOT possible to be transactional
								incomingEmails[i].setFlag(Flags.Flag.DELETED, true);
							} catch (MessagingException e) {
								logErrorGenerateException(this, methodName, POP3RetrieveNodeMessages.MESSAGE_SOURCE, POP3RetrieveNodeMessages.MSGEX, "MessagingException", new String[]{e.getMessage(), stackTraceToString(e)});
							}
							// Propagate to next node in the flow
							out.propagate(outAssembly);
						} finally {
							// clear the outMessage
							outMessage.clearMessage();
						}

					} catch (MbException e) {
						logError(this, methodName, POP3RetrieveNodeMessages.MESSAGE_SOURCE, POP3RetrieveNodeMessages.EX, "Exception", new String[]{e.getMessage(), stackTraceToString(e)});
						throw e;
					}
				}
			}
			// Close the folder to expunge the received mails.
			helper.disconnect();
		}
	}
}